#!/usr/local/bin/perl
#
# Find SMxPac distribution
#
# Find G03 executable

$path = `pwd`;chomp($path);
$libloc = "$path/SMxLib";
$sourceloc = "$path/smxgausssource";
$perlloc = `which perl`;
$perlloc = "\#\!$perlloc";

$status = 1;
while (not $query) {
print "Do you have a Gaussian03 executable and do you know where it ";
print "is located (yes or no)?\n";
$query = <STDIN>;chomp($query);
if ($query) {
   if ($query =~ m/yes/i) {
      print "What is the absolute path to the Gaussian03 executable?\n";
      $g03exe = <STDIN>;
      chomp($g03exe);
      $runmode = "mode2";
   }  elsif ($query =~ m/no/i) {
      $g03exe = "NOTDEFINED";
      $runmode = "mode1";
   }   else {
   print "The answer to this question is yes or no, not $query.\n";
   $query = "";
   }
}

}
$query = "";chomp($query);

if ($runmode =~m/mode2/) {
while (not $query) {
print "Is your Gaussian03 executable version D01 or later?\n";
$query = <STDIN>;chomp($query);
if ($query) {
   if ($query =~ m/yes/i) {
      $version = 1;
   }  elsif ($query =~ m/no/i) {
      $version = 0;
   }   else {
   print "The answer to this question is yes or no, not $query.\n";
   $query = "";
   }
}
}
}
   
open(MOD, ">.mode");
print MOD "Mode\t$runmode\n";
close(MOD);

if ($runmode =~ m/mode1/) {
@code = qw(Gau_External smxg1.pl shell.csh);
}
elsif ($runmode =~m/mode2/) {
@code = qw(Gau_External smxg2.pl shell.csh);
}
@library   = qw(heading.lib initialize.lib molecspec.lib procbasis.lib
               procinput.lib prockeyword.lib proclogic.lib procopt.lib
               procoverride.lib procscf.lib procsmx.lib procsolvent.lib
               prtext.lib suminp.lib punch.lib procoutput.lib output.lib
               mode.lib mkhndplus.lib prochndplus.lib mkgauss.lib 
               procgauss.lib io.lib errmsg.lib);

`mkdir $libloc`;

for $i (0 .. $#code) {
    open(IN, "<$sourceloc/$code[$i]");
    open(OUT, ">$path/$code[$i]");
    while(<IN>) {
       s/PERL/$perlloc/g;
       s/SMXPATH/$path/g; 
       s/GAUSSIAN03/$g03exe/g;
       s/LIB/$libloc/g;
       if ($version == 1) {
          s/ARGV1/ARGV[1]/g;
          s/ARGV2/ARGV[2]/g;
       }
       else {
          s/ARGV1/ARGV[0]/g;
          s/ARGV2/ARGV[1]/g;
       }
       print OUT;
    }
    close(IN);close(OUT);
    `chmod u+x $path\/$code[$i]`;
}

for $i (0 .. $#library) {
    open(IN, "<$sourceloc/$library[$i]");
    open(OUT, ">$libloc\/$library[$i]");
    while(<IN>) {
       s/PERL/$perlloc/g;
       s/SMXPATH/$path/g;
       s/GAUSSIAN03/$g03exe/g;
       s/LIB/$libloc/g;
       print OUT;
    }
    close(IN);close(OUT);
}


