/*
NAME
     etime - return elapsed execution time

SYNOPSIS
     double precision function etime (tarray)
     real tarray(2)

DESCRIPTION 
     These routine return elapsed runtime in seconds.  The function
     value is the total time elapsed since the last bootup. The argument
     array returns user time in the first element and system time in the
     second element, summed up for the calling process and its child
     processes (if any).

AUTHOR
     Klaus-Peter Gulden (gulden@chemie.uni-wuerzburg.de)
     Date:   01.03.1994  OS: LinuX (Kernel 1.1.59) + gcc 2.5.8
*/
#include "f2c.h"
#include <time.h>
#include <sys/times.h>

double etime_(float *a)
{
  double        elapsed;
  struct tms    buf;
/*      CLK_TCK was originally CLOCKS_PER_SEC    */
  elapsed=times(&buf)/CLK_TCK;
  a[0]=(float)(buf.tms_utime + buf.tms_cutime)/CLK_TCK;
  a[1]=(float)(buf.tms_stime + buf.tms_cstime)/CLK_TCK;
  return(elapsed);
}

/*

NAME
     fdate - return date and time in an	ASCII string

SYNOPSIS
     subroutine	fdate(string)
     character*24 string

DESCRIPTION
     Fdate returns the current date and	time as	a 24 character string in the
     format described under ctime(3).  Neither `newline' nor NULL will be
     included.

AUTHOR
     Istvan Cserny (cserny@atomki.hu)
     Date:   21.06.1995  OS: LinuX (Kernel 1.1.59) + gcc 2.5.8
*/

void fdate_(char *cht, ftnlen cht_len)
{
    static time_t t;
    time(&t);
    s_copy(cht,ctime(&t),24L,24L);
    return;
}
