      SUBROUTINE FILARG(INPUT_FILE,OUTPUT_FILE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*8   ERRMSG
      CHARACTER*80  INPUT_FILE
      CHARACTER*80 OUTPUT_FILE
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-FILARG-'/
C
C     ----- GET INPUT AND OUTPUT FILE NAMES FROM ARGUMENTS -----
C
      CALL GETARG(1,INPUT_FILE)
      IF(INPUT_FILE.EQ.' ') THEN
         PRINT *, 'Enter the file name for the input file'
         READ (*,9999) INPUT_FILE
      ENDIF
      IF(INPUT_FILE.EQ.' ') THEN
         PRINT *,'An input file name must be given. stop'
         CALL HNDERR(3,ERRMSG)
      ENDIF
      CALL GETARG(2,OUTPUT_FILE)
      IF(OUTPUT_FILE.EQ.' ') THEN
         PRINT *, 'Enter the file name for the output file'
         READ (*,9999) OUTPUT_FILE
      ENDIF
      IF(OUTPUT_FILE.EQ.' ') THEN
         PRINT *,'An output file name must be given. stop'
         CALL HNDERR(3,ERRMSG)
      ENDIF
C
      RETURN
 9999 FORMAT(A80)
      END
      SUBROUTINE MODFIL(OUTPUT_FILE)
      CHARACTER*80 OUTPUT_FILE
      CHARACTER*80 CLUSTER_FILE
      COMMON/LCAPID/NAP,IAP
C
      IF(IAP.EQ.1) RETURN
C
C     ------ CONSTRUCT DIFFERENT FILENAMES FOR EACH NODE IAP.GT.1 -----
C
      I=80
      DO WHILE(I.GT.1.AND.OUTPUT_FILE(I:I).NE.'.')
         I=I-1
      ENDDO
      IF(IAP.GE.100) THEN
         I1=(IAP)/100
         I2=(IAP-I1*100)/10
         I3=(IAP-I1*100-I2*10)/1
         CLUSTER_FILE = OUTPUT_FILE(1:I)//CHAR(ICHAR('0')+I1)//     
     1               CHAR(ICHAR('0')+I2)//CHAR(ICHAR('0')+I3)//
     2                               '.'//OUTPUT_FILE(I+1:)
      ELSEIF(IAP.GE.10) THEN
         I1=(IAP)/10
         I2=(IAP-I1*10)/1
         CLUSTER_FILE = OUTPUT_FILE(1:I)//CHAR(ICHAR('0')+I1)//
     1                                    CHAR(ICHAR('0')+I2)//
     2                               '.'//OUTPUT_FILE(I+1:)
      ELSE
         I1=(IAP)/1
         CLUSTER_FILE = OUTPUT_FILE(1:I)//CHAR(ICHAR('0')+I1)//
     1                               '.'//OUTPUT_FILE(I+1:)
      ENDIF
      OUTPUT_FILE = CLUSTER_FILE
C
      RETURN
      END
C#g77 SUBROUTINE FILEINF()
C#g77 RETURN
C#g77 END
      SUBROUTINE FIOPEN(NFT,NXTENT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MXFIL= 30)
      CHARACTER*80 DSNAME
      CHARACTER*6  STAT
      CHARACTER*8  ERRMSG
      COMMON/IOFILE/IR,IW,IP
      COMMON/FILDEF/DSNAME(MXFIL),STAT(MXFIL)
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-FIOPEN-'/
C
      IF(NFT.GT.MXFIL.OR.NFT.LE. 0                    ) GO TO 30
      IF(NFT.EQ.    4.OR.NFT.EQ. 7.OR.NFT.EQ.27       ) GO TO 10
      IF(NFT.EQ.    2.OR.NFT.EQ. 3.OR.MOD(NFT,10).EQ.0) GO TO 20
C
C     ----- SEQUENTIAL FILES -----
C
      OPEN(UNIT=NFT,FILE=DSNAME(NFT),STATUS='UNKNOWN',
     1     ACCESS='SEQUENTIAL',FORM='UNFORMATTED',ERR=30)
      RETURN
C
C     ----- FORMATTED FILES -FT04- , -FT07- AND -FT27- -----
C
   10 CONTINUE
      OPEN(UNIT=NFT,FILE=DSNAME(NFT),STATUS='UNKNOWN',
     1     ACCESS='SEQUENTIAL',FORM=  'FORMATTED',ERR=30)
      RETURN
C
C     ----- DIRECT ACCESS FILES -----
C
   20 CONTINUE
                    NN = 8192
      IF(NFT.EQ. 2) NN = 6016
      IF(NFT.EQ. 3) NN = 4000
C
      IF(MOD(NFT,10).NE.0) THEN
         OPEN(UNIT=NFT,FILE=DSNAME(NFT),STATUS='UNKNOWN',RECL=NN,
     1        ACCESS=    'DIRECT',FORM='UNFORMATTED',ERR=30)
      ENDIF
C
      RETURN
C
C     ----- ERROR MESSAGE ----- AND STOP THE JOB -----
C
   30 WRITE(IW,9999) NFT
      CALL HNDERR(3,ERRMSG)
      RETURN
 9999 FORMAT(/,' ------  ERROR OPENING UNIT ',I3,' --- STOP ---')
      END
      SUBROUTINE FILEND
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MXFIL= 30)
C
C     ----- ROUTINE TO CLOSE ALL THE FILES -----
C
      DO I=2,MXFIL
         IF(I.NE.6) THEN
            CALL FICLOS(I)
         ENDIF
      ENDDO
      CALL FICLOS(6)
C
      RETURN
      END
      SUBROUTINE FICLOS(NFT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MXFIL= 30)
      CHARACTER*24 ERRMSG
      CHARACTER*80 DSNAME
      CHARACTER*6  STAT
      COMMON/IOFILE/IR,IW,IP
      COMMON/FILDEF/DSNAME(MXFIL),STAT(MXFIL)
      DATA ERRMSG /'PROGRAM STOP IN -FICLOS-'/
C
      CLOSE(UNIT=NFT,STATUS=STAT(NFT),ERR=10)
      RETURN
   10 WRITE(IW,9999) NFT
      RETURN
 9999 FORMAT(/,' ----- ERROR CLOSING UNIT ',I3,' --- STOP ---')
      END
      SUBROUTINE FICLS5(NFT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      RETURN
      END
C     SUBROUTINE FIFLSH(NFT)
C     IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C     CALL FLUSH_(NFT)
C     CALL FLUSH(NFT)
C     RETURN
C     END
      SUBROUTINE FILINF(ICODE,NREC)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      RETURN
      END
      SUBROUTINE STRPSF(LONGNAME,SHORTNAME,PATH)
      character*(*) longname, shortname, path
      last = len(longname)
      i = last
      do while ( i.ge.1 .and. longname(i:i).ne.'/' )
         i = i-1
      enddo
      if(i.eq.0) then
         path = ' '
      else
         path = longname(1:i)
      endif
      j = last
      do while ( j.gt.i .and. longname(j:j).ne.'.' )
         j = j-1
      enddo
      if(j.eq.i) then
         shortname = longname(i+1:last)
      else
         shortname = longname(i+1:j-1)
      endif
      return
      end
      SUBROUTINE CONCAT(PATH,FILEN,FILET,STRING,FORM)
C=======================================================================
C
C    Concatentate two strings into a single string variable
C    The maximum length of the final string variable should
C    be 80 characters
C
C=======================================================================
      CHARACTER*3   OPER
      CHARACTER*80  STRING,BLANKS,PATH
      CHARACTER*80  FILEN,FILET
      CHARACTER*11  FRM
      CHARACTER*10  ACC
      CHARACTER*1   FORM
      LOGICAL       FEXIST
      DATA BLANKS(1:80) /' '/
C
      oper   = 'aix'
      string = blanks
C
C  If a path exists, then use it.
C
      i1 = 1
      do while ((i1 .le. len(path)) .and. (path(i1:i1) .ne. ' '))
         string (i1:i1) = path (i1:i1)
         i1 = i1 + 1
      enddo
C
C Add the / at the end of the directory path if path exists
C
      if (i1.gt.1 .and. string(i1-1:i1-1).ne.'/') then
         if (oper (1:3) .EQ. 'aix') then
            string (i1:i1) = '/'
         else if (oper (1:3) .eq. 'mvs') then
            string (i1:i1) = '.'
         endif
         i1 = i1 + 1
      endif
C
C Find the first nonblank in the file name.
C
      j=1
      Do while ((j .le. len(filen)) .and. (filen(j:j) .eq. ' '))
        j=j+1
      enddo
C
C Now concatenate the file name.
C
      i=j
      do while ((i .le. len(filen)) .and. (filen(i:i) .ne. ' '))
         string (i1:i1) = filen (i:i)
         i1 = i1 + 1
         i=i+1
      enddo
C
C Find the first nonblank in the file type.
C
      j=1
      Do while ((j .le. len(filet)) .and. (filet(j:j) .eq. ' '))
        j=j+1
      enddo
C
C Add the . between the file name and the file type if there is a
C file type.
C
      i=j
      if (i .le. len(filet)) then
         string (i1:i1) = '.'
         i1 = i1 + 1
C
C       Now concatenate the file type.
C
         do while ((i .le. len(filet)) .and. (filet(i:i) .ne. ' '))
            string (i1:i1) = filet (i:i)
            i1 = i1 + 1
            i=i+1
         enddo
      endif
c
C#g77 if (oper (1:3) .eq. 'mvs') then
C#g77         inquire (file=string,exist=fexist)
C#g77         if (.not. fexist) then
C#g77            if (form .eq. 'f' .or. form .eq. 'f') then
C#g77           call fileinf (ircode,'lrecl',len(string),
C#g77 1         'recfm', 'fb','trk',10,'second',10,'blksize',32760)
C#g77       else
C#g77       call fileinf (ircode,'lrecl',len(string),
C#g77 1         'recfm','vbs','trk',10,'second',10,'blksize',10000)
C#g77     endif
C#g77   endif
C#g77 endif
C#g77
      RETURN
      END
      SUBROUTINE DACLOS(IDAF,NAV,IW)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MXFIL= 30)
      CHARACTER*80 DSNAME
      CHARACTER*6  STAT
      COMMON/FILDEF/DSNAME(MXFIL),STAT(MXFIL)
      CLOSE(UNIT=IDAF,STATUS=STAT(IDAF))
      RETURN
      END
      SUBROUTINE RACLOS(IDAF,NAV,IW)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MXFIL= 30)
      CHARACTER*80 DSNAME
      CHARACTER*6  STAT
      COMMON/FILDEF/DSNAME(MXFIL),STAT(MXFIL)
      CLOSE(UNIT=IDAF,STATUS=STAT(IDAF))
      RETURN
      END
      SUBROUTINE DAOPEN(IDAF,IODA,NAV,NDAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     ----- OPEN A DIRECT ACCESS FILE -----
C        IDAF ..... FORTRAN FILE NUMBER
C        IODA ..... INDEX ARRAY OF LENGTH -NDAR-
C        NAV  ..... ASSOCIATED VARIABLE
C        NDAR ..... NUMBER OF -DA- INDEX WORDS
C                   IT MUST BE EQUAL TO 1 + NUMBER
C                   OF LOGICAL RECORDS TO BE
C                   WRITTEN ON -IDAF-.
C
      PARAMETER (MXFIL= 30)
      CHARACTER*80 DSNAME
      CHARACTER*6  STAT
      COMMON/FILDEF/DSNAME(MXFIL),STAT(MXFIL)
      COMMON/DAFNAV/IXDDAF(2048),NAV10,NAV20
      DIMENSION IODA(NDAR)
      LDAR=2048
      DO 10 I=1,NDAR
   10 IODA(I)=0
C
      IF(IDAF.NE.10) GO TO 20
      NAV  =1
      NAV10=1
      OPEN(UNIT=IDAF,STATUS='UNKNOWN',ACCESS='DIRECT',
     1 RECL=8192,FORM='UNFORMATTED',FILE=DSNAME(IDAF))
      RETURN
   20 CONTINUE
      NAV  =1
      NAV20=1
      OPEN(UNIT=IDAF,STATUS='UNKNOWN',ACCESS='DIRECT',
     1 RECL=8192,FORM='UNFORMATTED',FILE=DSNAME(IDAF))
      RETURN
      END
      SUBROUTINE RAOPEN(IDAF,IODA,NAV,NDAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     ----- OPEN A DIRECT ACCESS FILE -----
C        IDAF ..... FORTRAN FILE NUMBER
C        IODA ..... INDEX ARRAY OF LENGTH -NDAR-
C        NAV  ..... ASSOCIATED VARIABLE
C        NDAR ..... NUMBER OF -DA- INDEX WORDS
C                   IT MUST BE EQUAL TO 1 + NUMBER
C                   OF LOGICAL RECORDS TO BE
C                   WRITTEN ON -IDAF-.
C
      PARAMETER (MXFIL= 30)
      CHARACTER*80 DSNAME
      CHARACTER*6  STAT
      COMMON/FILDEF/DSNAME(MXFIL),STAT(MXFIL)
      COMMON/RAFNAV/IXDDAF(2048),NAV30,NAV40
      DIMENSION IODA(NDAR)

      LDAR=1024
      DO 10 I=1,NDAR
   10 IODA(I)=0
C
      IF(IDAF.NE.30) GO TO 20
      NAV  =1
      NAV30=1
      OPEN(UNIT=IDAF,STATUS='UNKNOWN',ACCESS='DIRECT',
     1 RECL=8192,FORM='UNFORMATTED',FILE=DSNAME(IDAF))
      RETURN
   20 CONTINUE
      NAV  =1
      NAV40=1
      OPEN(UNIT=IDAF,STATUS='UNKNOWN',ACCESS='DIRECT',
     1 RECL=8192,FORM='UNFORMATTED',FILE=DSNAME(IDAF))
      RETURN
      END
      SUBROUTINE DATABL
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (MXIODA=255)
      CHARACTER*32 DARNAM
      COMMON/DAFTBL/DARNAM(MXIODA)
      COMMON/DAFREC/LENDAR(MXIODA)
C
      NDARMX=MXIODA
C
      ENTRY NMTABL
C
      DO IDAR=1,NDARMX
         DARNAM(IDAR)=':HONDO:                         '
      ENDDO
      DO IDAR=1,NDARMX
         LENDAR(IDAR)=0
      ENDDO
C
      RETURN
      END
      SUBROUTINE DAWRIT(IDAF,IODA,IX,NX,IDAR,NAV)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      PARAMETER (MXIODA=255)
      LOGICAL OUT
      COMMON/IOFILE/IR,IW                                       !SMxGauss
      COMMON/MACHIN/ISINGL,NBITS
      COMMON/DAFNAV/IXDDAF(2048),NAV10,NAV20
      COMMON/DAFREC/LENDAR(MXIODA)
      DIMENSION ERRMSG(3)
      DIMENSION IODA(1),IX(1)
      DIMENSION IXSDAF(1024)
      EQUIVALENCE (IXSDAF(1),IXDDAF(1))
      DATA ERRMSG /'PROGRAM ','STOP IN ','-DAWRIT-'/
      DATA IXMAX  /1024/
C
      OUT=.FALSE.
C
      MAXIX=IXMAX*ISINGL
      LDAR =   NX*ISINGL
      IF(IODA(IDAR+0).NE.0) GO TO 100
C
C     ----- FIRST WRITE -----
C
      IODA(IDAR+0)=NAV
      IF(IDAF.EQ.10) NAV10=NAV
      IF(IDAF.EQ.20) NAV20=NAV
C
      IF(IDAF.EQ.10) THEN
         LENDAR(IDAR+0)=NX
         IF(OUT) THEN
            WRITE(IW,9998) IDAR,NX
         ENDIF
      ENDIF
C
      MAX=0
   10 MIN=MAX+1
      MAX=MAX+MAXIX
      IF(MAX.GT.LDAR) MAX=LDAR
      DO 20 I=MIN,MAX
   20 IXDDAF(I-MIN+1)=IX(I)
      IF(IDAF.EQ.10.AND.NAV10.LE.0) THEN
         WRITE(IW,9996) IDAF,IDAR,NAV10
         CALL HNDERR(3,ERRMSG)
      ELSEIF(IDAF.EQ.20.AND.NAV20.LE.0) THEN
         WRITE(IW,9996) IDAF,IDAR,NAV20
         CALL HNDERR(3,ERRMSG)
      ENDIF
      IF(IDAF.EQ.10.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV10) IXSDAF
      IF(IDAF.EQ.10.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV10) IXDDAF
      IF(IDAF.EQ.20.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV20) IXSDAF
      IF(IDAF.EQ.20.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV20) IXDDAF
      IF(IDAF.EQ.10) NAV10=NAV10+1
      IF(IDAF.EQ.20) NAV20=NAV20+1
      IF(MAX.LT.LDAR) GO TO 10
C
      IF(IDAF.EQ.10) NAV=NAV10
      IF(IDAF.EQ.20) NAV=NAV20
      RETURN
C
C     ----- REWRITE -----
C
  100 CONTINUE
      IF(IDAF.EQ.10) NAV10=IODA(IDAR+0)
      IF(IDAF.EQ.20) NAV20=IODA(IDAR+0)
C
      IF(IDAF.EQ.10) THEN
         IF(OUT) THEN
            WRITE(IW,9997) IDAR,NX
         ENDIF
         NX0=LENDAR(IDAR+0)
         IF(NX.GT.NX0) THEN
            IF(OUT) THEN
               WRITE(IW,9999) IDAR,NX,NX0
               CALL HNDERR(3,ERRMSG)
            ENDIF
         ELSEIF(NX.LT.NX0) THEN
            IF(OUT) THEN
               WRITE(IW,9999) IDAR,NX,NX0
            ENDIF
         ENDIF
      ENDIF
C
      MAX=0
  110 MIN=MAX+1
      MAX=MAX+MAXIX
      IF(MAX.GT.LDAR) MAX=LDAR
      DO 120 I=MIN,MAX
  120 IXDDAF(I-MIN+1)=IX(I)
      IF(IDAF.EQ.10.AND.NAV10.LE.0) THEN
         WRITE(IW,9996) IDAF,IDAR,NAV10
         CALL HNDERR(3,ERRMSG)
      ELSEIF(IDAF.EQ.20.AND.NAV20.LE.0) THEN
         WRITE(IW,9996) IDAF,IDAR,NAV20
         CALL HNDERR(3,ERRMSG)
      ENDIF
      IF(IDAF.EQ.10.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV10) IXSDAF
      IF(IDAF.EQ.10.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV10) IXDDAF
      IF(IDAF.EQ.20.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV20) IXSDAF
      IF(IDAF.EQ.20.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV20) IXDDAF
      IF(IDAF.EQ.10) NAV10=NAV10+1
      IF(IDAF.EQ.20) NAV20=NAV20+1
      IF(MAX.LT.LDAR) GO TO 110
C
      RETURN
 9999 FORMAT(' INCONSISTENT RECORD LENGTH FOR -IDAR- = ',I4,/,
     1       ' NX,NX0 = ',2I10)
 9998 FORMAT(' FIRST-WRITE, IDAR = ',I5,' LENGTH = ',I10)
 9997 FORMAT('    RE-WRITE, IDAR = ',I5,' LENGTH = ',I10)
 9996 FORMAT(' -DA- RECORD OUT OF RANGE IN -DAWRIT-,',
     1       ' IDAF,IDAR,NAV = ',I3,2I7)
      END
      SUBROUTINE DAREAD(IDAF,IODA,IX,NX,IDAR)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      COMMON/IOFILE/IR,IW                                       !SMxGauss
      COMMON/MACHIN/ISINGL,NBITS
      COMMON/DAFNAV/IXDDAF(2048),NAV10,NAV20
      DIMENSION ERRMSG(3)
      DIMENSION IODA(1),IX(1)
      DIMENSION IXSDAF(1024)
      EQUIVALENCE (IXSDAF(1),IXDDAF(1))
      DATA IXMAX  /1024/
      DATA ERRMSG /'PROGRAM ','STOP IN ','-DAREAD-'/
C
      IF(IDAF.EQ.10) NAV10=IODA(IDAR+0)
      IF(IDAF.EQ.20) NAV20=IODA(IDAR+0)
      MAXIX=IXMAX*ISINGL
      LDAR =   NX*ISINGL
C
      MAX=0
   10 MIN=MAX+1
      MAX=MAX+MAXIX
      IF(MAX.GT.LDAR) MAX=LDAR
      IF(IDAF.EQ.10.AND.NAV10.LE.0) THEN
         WRITE(IW,9999) IDAF,IDAR,NAV10
         CALL HNDERR(3,ERRMSG)
      ELSEIF(IDAF.EQ.20.AND.NAV20.LE.0) THEN
         WRITE(IW,9999) IDAF,IDAR,NAV20
         CALL HNDERR(3,ERRMSG)
      ENDIF
      IF(IDAF.EQ.10.AND.ISINGL.EQ.1) READ(IDAF,REC=NAV10) IXSDAF
      IF(IDAF.EQ.10.AND.ISINGL.EQ.2) READ(IDAF,REC=NAV10) IXDDAF
      IF(IDAF.EQ.20.AND.ISINGL.EQ.1) READ(IDAF,REC=NAV20) IXSDAF
      IF(IDAF.EQ.20.AND.ISINGL.EQ.2) READ(IDAF,REC=NAV20) IXDDAF
      DO 20 I=MIN,MAX
   20 IX(I)=IXDDAF(I-MIN+1)
      IF(IDAF.EQ.10) NAV10=NAV10+1
      IF(IDAF.EQ.20) NAV20=NAV20+1
      IF(MAX.LT.LDAR) GO TO 10
C
      RETURN
 9999 FORMAT(' -DA- RECORD OUT OF RANGE IN -DAREAD-,',
     1       ' IDAF,IDAR,NAV = ',I3,2I7)
      END
      SUBROUTINE DARTRN(IDAF)
      CLOSE(UNIT=IDAF,STATUS='KEEP')
      RETURN
      END
      SUBROUTINE RAWRIT(IDAF,IODA,IX,NX,IDAR,NAV)
      IMPLICIT REAL*8 (A-H,O-Z)
C#g77 COMMON/MACHIN/ISINGL
      COMMON/MACHIN/ISINGL,NBITS
      COMMON/RAFNAV/IXDDAF(2048),NAV30,NAV40
      DIMENSION IODA(1),IX(1)
      DIMENSION IXSDAF(1024)
      EQUIVALENCE (IXSDAF(1),IXDDAF(1))
      DATA IXMAX /1024/
C
      MAXIX=IXMAX*ISINGL
      LDAR =   NX*ISINGL
      IF(IODA(IDAR+0).NE.0) GO TO 100
C
C     ----- FIRST WRITE -----
C
      IODA(IDAR+0)=NAV
      IF(IDAF.EQ.30) NAV30=NAV
      IF(IDAF.EQ.40) NAV40=NAV
C
      MAX=0
   10 MIN=MAX+1
      MAX=MAX+MAXIX
      IF(MAX.GT.LDAR) MAX=LDAR
      DO 20 I=MIN,MAX
   20 IXDDAF(I-MIN+1)=IX(I)
      IF(IDAF.EQ.30.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV30) IXSDAF
      IF(IDAF.EQ.30.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV30) IXDDAF
      IF(IDAF.EQ.40.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV40) IXSDAF
      IF(IDAF.EQ.40.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV40) IXDDAF
      IF(IDAF.EQ.30) NAV30=NAV30+1
      IF(IDAF.EQ.40) NAV40=NAV40+1
      IF(MAX.LT.LDAR) GO TO 10
C
      IF(IDAF.EQ.30) NAV=NAV30
      IF(IDAF.EQ.40) NAV=NAV40
      RETURN
C
C     ----- REWRITE -----
C
  100 CONTINUE
      IF(IDAF.EQ.30) NAV30=IODA(IDAR+0)
      IF(IDAF.EQ.40) NAV40=IODA(IDAR+0)
C
      MAX=0
  110 MIN=MAX+1
      MAX=MAX+MAXIX
      IF(MAX.GT.LDAR) MAX=LDAR
      DO 120 I=MIN,MAX
  120 IXDDAF(I-MIN+1)=IX(I)
      IF(IDAF.EQ.30.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV30) IXSDAF
      IF(IDAF.EQ.30.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV30) IXDDAF
      IF(IDAF.EQ.40.AND.ISINGL.EQ.1) WRITE(IDAF,REC=NAV40) IXSDAF
      IF(IDAF.EQ.40.AND.ISINGL.EQ.2) WRITE(IDAF,REC=NAV40) IXDDAF
      IF(IDAF.EQ.30) NAV30=NAV30+1
      IF(IDAF.EQ.40) NAV40=NAV40+1
      IF(MAX.LT.LDAR) GO TO 110
      RETURN
      END
      SUBROUTINE RAREAD(IDAF,IODA,IX,NX,IDAR)
      IMPLICIT REAL*8 (A-H,O-Z)
C#g77 COMMON/MACHIN/ISINGL
      COMMON/MACHIN/ISINGL,NBITS
      COMMON/DAFNAV/IXDDAF(2048),NAV30,NAV40
      DIMENSION IODA(1),IX(1)
      DIMENSION IXSDAF(1024)
      EQUIVALENCE (IXSDAF(1),IXDDAF(1))
      DATA IXMAX /1024/
C
      IF(IDAF.EQ.30) NAV30=IODA(IDAR+0)
      IF(IDAF.EQ.40) NAV40=IODA(IDAR+0)
      MAXIX=IXMAX*ISINGL
      LDAR =   NX*ISINGL
C
      MAX=0
   10 MIN=MAX+1
      MAX=MAX+MAXIX
      IF(MAX.GT.LDAR) MAX=LDAR
      IF(IDAF.EQ.30.AND.ISINGL.EQ.1) READ(IDAF,REC=NAV30) IXSDAF
      IF(IDAF.EQ.30.AND.ISINGL.EQ.2) READ(IDAF,REC=NAV30) IXDDAF
      IF(IDAF.EQ.40.AND.ISINGL.EQ.1) READ(IDAF,REC=NAV40) IXSDAF
      IF(IDAF.EQ.40.AND.ISINGL.EQ.2) READ(IDAF,REC=NAV40) IXDDAF
      DO 20 I=MIN,MAX
   20 IX(I)=IXDDAF(I-MIN+1)
      IF(IDAF.EQ.30) NAV30=NAV30+1
      IF(IDAF.EQ.40) NAV40=NAV40+1
      IF(MAX.LT.LDAR) GO TO 10
      RETURN
      END
      SUBROUTINE RARTRN(IDAF)
      CLOSE(UNIT=IDAF,STATUS='KEEP')
      RETURN
      END
      SUBROUTINE REWFIL(NFT)
      IMPLICIT REAL*8 (A-H,O-Z)
      REWIND NFT
      RETURN
      END
      SUBROUTINE ADVFIL(IJK,IPK,PANDK)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PANDK
      LOGICAL PACK2E
      COMMON/PCKOPT/NHEX,NTUPL,PACK2E
      COMMON/INTOPT/NOPK,NOK,NOSQUR
      COMMON/INTFIL/NINTMX
      IF(PACK2E) GO TO 10
      READ(IJK)
      IF(PANDK) READ(IPK)
      RETURN
   10 CALL ADVPK(IJK,NXX,IERR,IEND)
      IF(PANDK) CALL ADVPK(IPK,NXX,IERR,IEND)
      CALL ADVPN(IJK,NXX,IERR,IEND)
      IF(PANDK) CALL ADVPN(IPK,NXX,IERR,IEND)
      RETURN
      END
      SUBROUTINE PREAD(IJK,XX,IX,NXX,MAX)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PACK2E
      COMMON/PCKLAB/LABSIZ
      COMMON/PCKOPT/NHEX,NTUPL,PACK2E
      COMMON/INTOPT/NOPK,NOK,NOSQUR
      COMMON/INTFIL/NINTMX
      DIMENSION XX(MAX),IX(LABSIZ*MAX)
      IF(PACK2E) GO TO 10
      READ(IJK) XX,IX,NX
      NXX=NX
      RETURN
   10 CALL READPK(IJK,XX,XX,       NXX,NH,IERR,IEND)
      CALL READPN(IJK,IX,IX,LABSIZ*NXX,NT,IERR,IEND)
      RETURN
      END
      SUBROUTINE PKREAD(IP,IK,XP,XK,IX,NXX,MAX)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PACK2E
      COMMON/PCKLAB/LABSIZ
      COMMON/PCKOPT/NHEX,NTUPL,PACK2E
      COMMON/INTOPT/NOPK,NOK,NOSQUR
      COMMON/INTFIL/NINTMX
      DIMENSION XP(MAX),XK(MAX),IX(LABSIZ*MAX)
      IF(PACK2E) GO TO 10
      READ(IP) XP,IX,NX
      READ(IK) XK,IX,NX
      NXX=NX
      RETURN
   10 CALL READPK(IP,XP,XP,       NXX,NH,IERR,IEND)
      CALL READPK(IK,XK,XK,       NXX,NH,IERR,IEND)
      CALL READPN(IP,IX,IX,LABSIZ*NXX,NT,IERR,IEND)
      CALL READPN(IK,IX,IX,LABSIZ*NXX,NT,IERR,IEND)
      RETURN
      END
      SUBROUTINE PWRIT(IJK,XX,IX,NXX,MAX)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PACK2E
      COMMON/PCKLAB/LABSIZ
      COMMON/PCKOPT/NHEX,NTUPL,PACK2E
      COMMON/INTOPT/NOPK,NOK,NOSQUR
      COMMON/INTFIL/NINTMX
      DIMENSION XX(MAX),IX(LABSIZ*MAX)
      IF(PACK2E) GO TO 10
      NX=NXX
      WRITE(IJK) XX,IX,NX
      RETURN
   10 CONTINUE
      N=NXX
      CALL WRITPK(IJK,XX,XX,N,NHEX)
      N=NXX*LABSIZ
      CALL WRITPN(IJK,IX,IX,N,NTUPL)
      RETURN
      END
      SUBROUTINE PKWRIT(IP,IK,XP,XK,IX,NXX,MAX)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL PACK2E
      COMMON/PCKLAB/LABSIZ
      COMMON/PCKOPT/NHEX,NTUPL,PACK2E
      COMMON/INTOPT/NOPK,NOK,NOSQUR
      COMMON/INTFIL/NINTMX
      DIMENSION XP(MAX),XK(MAX),IX(LABSIZ*MAX)
      IF(PACK2E) GO TO 10
      NX=NXX
      WRITE(IP) XP,IX,NX
      WRITE(IK) XK,IX,NX
      RETURN
   10 CONTINUE
      N=NXX
      CALL WRITPK(IP,XP,XP,N,NHEX)
      N=NXX
      CALL WRITPK(IK,XK,XK,N,NHEX)
      N=NXX*LABSIZ
      CALL WRITPN(IP,IX,IX,N,NTUPL)
      N=NXX*LABSIZ
      CALL WRITPN(IK,IX,IX,N,NTUPL)
      RETURN
      END
      SUBROUTINE ADVPK(IS,NNX,IERR,IEND)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-ADVPK -'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE ADVPN(IS,NNX,IERR,IEND)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-ADVPN -'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE READPK(IS,XX,YY,NXX,NH,IERR,IEND)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-READPK-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE READPN(IS,IX,IY,NNX,NT,IERR,IEND)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-READPN-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE WRITPK(IS,XX,YY,N,NHEX)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-WRITPK-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE WRITPN(IS,IX,IY,N,NTUPL)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-WRITPN-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE INITPK(A)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-INITPK-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE INITPN(A)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-INITPN-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE EXITPK
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-EXITPK-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
      SUBROUTINE EXITPN
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 ERRMSG
      DIMENSION ERRMSG(3)
      DATA ERRMSG /'PROGRAM ','STOP IN ','-EXITPN-'/
      CALL HNDERR(3,ERRMSG)
      RETURN
      END
